package com.rma.epstopik_bengaliword;

import androidx.appcompat.app.AppCompatActivity;
import androidx.core.content.ContextCompat;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.Toast;

public class ChapterActivity extends AppCompatActivity {

     ListView chapert_listView;
    private int[] chapterResourceIds;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        long startTime = System.currentTimeMillis();
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_chapter);
        getWindow().setStatusBarColor(ContextCompat.getColor(this, R.color.status));

        chapert_listView = findViewById(R.id.chapert_listView);

        // Initialize chapterResourceIds with resource IDs
        chapterResourceIds = new int[]{
                R.array.chapter_1,
                R.array.chapter_2,
                R.array.chapter_3,
                R.array.chapter_4,
                R.array.chapter_5,
                R.array.chapter_6,
                R.array.chapter_7,
                R.array.chapter_8,
                R.array.chapter_9,
                R.array.chapter_10,
                R.array.chapter_11,
                R.array.chapter_12,
                R.array.chapter_13,
                R.array.chapter_14,
                R.array.chapter_15,
                R.array.chapter_16,
                R.array.chapter_17,
                R.array.chapter_18,
                R.array.chapter_19,
                R.array.chapter_20,
                R.array.chapter_21,
                R.array.chapter_22,
                R.array.chapter_23,
                R.array.chapter_24,
                R.array.chapter_25,
                R.array.chapter_26,
                R.array.chapter_27,
                R.array.chapter_28,
                R.array.chapter_29,
                R.array.chapter_30,
                R.array.chapter_31,
                R.array.chapter_32,
                R.array.chapter_33,
                R.array.chapter_34,
                R.array.chapter_35,
                R.array.chapter_36,
                R.array.chapter_37,
                R.array.chapter_38,
                R.array.chapter_39,
                R.array.chapter_40,
                R.array.chapter_41,
                R.array.chapter_42,
                R.array.chapter_43,
                R.array.chapter_44,
                R.array.chapter_45,
                R.array.chapter_46,
                R.array.chapter_47,
                R.array.chapter_48,
                R.array.chapter_49
        };


        String[] chapterNames = getResources().getStringArray(R.array.chapter_name);
        ArrayAdapter<String> adapter = new ArrayAdapter<>(this, R.layout.chapter_item_viewer, R.id.chapter_textView, chapterNames);
        chapert_listView.setAdapter(adapter);

        chapert_listView.setOnItemClickListener((parent, view, position, id) -> handleItemClick(position));

        long endTime = System.currentTimeMillis();
        Log.d("ChapterActivity", "onCreate execution time: " + (endTime - startTime) + " ms");
    }

    private void handleItemClick(int position) {
        if (position >= 0 && position < chapterResourceIds.length) {
            int resId = chapterResourceIds[position];  // Get the resource ID directly
            String[] strings = getResources().getStringArray(resId);

            Intent intent = new Intent(ChapterActivity.this, WordActivity.class);
            WordActivity.strings = strings;
            startActivity(intent);
        } else {
            Toast.makeText(this, "data is missing", Toast.LENGTH_SHORT).show();
        }
    }

    @Override
    public void onBackPressed() {
        MainActivity.currentDialog.dismiss();
        super.onBackPressed();
    }
}
