package com.rma.epstopik_bengaliword;


import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.viewpager2.widget.ViewPager2;

import android.os.Bundle;
import android.view.View;
import android.widget.LinearLayout;

import com.google.android.gms.ads.AdError;
import com.google.android.gms.ads.FullScreenContentCallback;
import com.google.android.material.tabs.TabLayout;
import com.rma.epstopik_bengaliword.Admov.AdClass;
import com.rma.epstopik_bengaliword.Admov.ControlAd;
import com.rma.epstopik_bengaliword.fragments.HangulAdapter;
public class HangulActivity extends AppCompatActivity {

    TabLayout tablayout;
    ViewPager2 viewPager2;



    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_hangul);

        AdClass.requestFullScreenAds(HangulActivity.this);
        // Load banner ad
        LinearLayout fAd_container=findViewById(R.id.banner_container);
        if (fAd_container!=null){
            AdClass.requestFb_BannerAds(this,fAd_container);
        }else if (fAd_container==null){
            fAd_container.setVisibility(View.GONE);
        }



        tablayout=findViewById(R.id.Tablayout);
        viewPager2=findViewById(R.id.viewPager);

        HangulAdapter hangulAdapter=new HangulAdapter(this);
        viewPager2.setAdapter(hangulAdapter);


        tablayout.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @Override
            public void onTabSelected(TabLayout.Tab tab) {
                viewPager2.setCurrentItem(tab.getPosition());

            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {

            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {

            }
        });

        viewPager2.registerOnPageChangeCallback(new ViewPager2.OnPageChangeCallback() {
            @Override
            public void onPageSelected(int position) {
                super.onPageSelected(position);
                tablayout.getTabAt(position).select();
                tablayout.getTabRippleColor().getDefaultColor();
            }
        });

    }

    @Override
    protected void onDestroy() {
        if (AdClass.faceBookadView!=null){
            AdClass.faceBookadView.destroy();
        }
        super.onDestroy();
    }

    @Override
    public void onBackPressed() {
        if (ControlAd.Clicked>=3) {
            if (AdClass.mInterstitialAd!=null){
                AdClass.mInterstitialAd.show(this);
                AdClass.mInterstitialAd.setFullScreenContentCallback(new FullScreenContentCallback() {
                    @Override
                    public void onAdDismissedFullScreenContent() {
                        super.onAdDismissedFullScreenContent();
                        AdClass.loadFullScreenAd(HangulActivity.this);
                        HangulActivity.super.onBackPressed();
                        ControlAd.Clicked=0;
                    }

                    @Override
                    public void onAdFailedToShowFullScreenContent(@NonNull AdError adError) {
                        super.onAdFailedToShowFullScreenContent(adError);}
                });
            }else {
                super.onBackPressed();
            }

        }else {
            super.onBackPressed();
            ControlAd.Clicked++;
        }
    }
}