package com.rma.epstopik_bengaliword;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;
import androidx.cardview.widget.CardView;
import androidx.core.content.ContextCompat;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.Toast;

import com.facebook.ads.AdSettings;
import com.facebook.ads.AudienceNetworkAds;
import com.google.android.gms.ads.MobileAds;
import com.google.android.ump.ConsentForm;
import com.google.android.ump.ConsentInformation;
import com.google.android.ump.ConsentRequestParameters;
import com.google.android.ump.UserMessagingPlatform;


public class MainActivity extends AppCompatActivity {
    CardView wordCard, bookCard, dictionaryCard, hangulCard, numberCard, practiceCard, wordTestCard, othersCard;
    Toolbar mytool;
    final String policy = "https://sites.google.com/view/epstopicbengaliword";
    final String delationrights = "https://sites.google.com/view/datadelationrights";
    private long lastBackPressed = 0;
    private static final long Double_Click_InterVal = 2000;
    public static AlertDialog currentDialog;
    static ConsentInformation consentInformation;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        getWindow().setStatusBarColor(ContextCompat.getColor(this, R.color.status));

    //initialize all id................................................................
        mytool = findViewById(R.id.mytool);
        mytool.setTitleTextColor(getColor(R.color.white));
        setSupportActionBar(mytool);
        wordCard = findViewById(R.id.wordid);
        hangulCard = findViewById(R.id.hangulid);
        bookCard = findViewById(R.id.bookid);
        dictionaryCard = findViewById(R.id.dictioneryid);
        practiceCard = findViewById(R.id.practiceid);
        numberCard = findViewById(R.id.numberid);
        wordTestCard = findViewById(R.id.wordTest);
        othersCard = findViewById(R.id.othersid);


        requstConsent();
        AudienceNetworkAds.initialize(this);
        MobileAds.initialize(this);
        AdSettings.addTestDevice("92e274f8-c6b7-4778-9bcb-a74e474fbafd");

    //listener method..................................................................................
        setClickListeners();

    }//Oncreate End here....................................................................

    private void setClickListeners() {
        wordCard.setOnClickListener(v -> {
            Intent intent = new Intent(MainActivity.this, ChapterActivity.class);
            MainActivity.showProgressDialogAndNavigate(MainActivity.this, intent);
        });

        bookCard.setOnClickListener(v -> {
            Intent intent = new Intent(MainActivity.this, BookActivity.class);
            MainActivity.showProgressDialogAndNavigate(MainActivity.this, intent);
        });

        wordTestCard.setOnClickListener(v -> {
            Intent intent = new Intent(MainActivity.this, TestChapter.class);
            MainActivity.showProgressDialogAndNavigate(MainActivity.this, intent);
        });

        hangulCard.setOnClickListener(v -> startActivity(new Intent(MainActivity.this, HangulActivity.class)));
        dictionaryCard.setOnClickListener(v -> startActivity(new Intent(MainActivity.this, DictioneryActivity.class)));
        practiceCard.setOnClickListener(v -> startActivity(new Intent(MainActivity.this, PracticeMainActivity.class)));
        numberCard.setOnClickListener(v -> startActivity(new Intent(MainActivity.this, NumberActivity.class)));
        othersCard.setOnClickListener(v -> startActivity(new Intent(MainActivity.this, OthersActivity.class)));

    }




    private void requstConsent() {
        // Create a ConsentRequestParameters object.
        ConsentRequestParameters params = new ConsentRequestParameters
                .Builder()
                .build();

        consentInformation = UserMessagingPlatform.getConsentInformation(this);
        consentInformation.requestConsentInfoUpdate(this,
                params,
                (ConsentInformation.OnConsentInfoUpdateSuccessListener) () -> {
                    UserMessagingPlatform.loadAndShowConsentFormIfRequired(this,
                            (ConsentForm.OnConsentFormDismissedListener) loadAndShowError -> {
                                if (loadAndShowError != null) {
                                }
                                // Consent has been gathered.
                                if (consentInformation.canRequestAds()) {
                                   MobileAds.initialize(this);
                                }
                            }
                    );
                },
                (ConsentInformation.OnConsentInfoUpdateFailureListener) requestConsentError -> {
                    // Consent gathering failed.
                });
        if (consentInformation.canRequestAds()) {
            MobileAds.initialize(this);
        }

}

    public static void showProgressDialogAndNavigate(Context context, Intent intent) {
        if (currentDialog != null && currentDialog.isShowing()) {
            currentDialog.dismiss();
        }

        AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(context);
        View dialogView = LayoutInflater.from(context).inflate(R.layout.dialog_ad, null);
        alertDialogBuilder.setView(dialogView);
        currentDialog = alertDialogBuilder.create();

        currentDialog.show();
        new Handler().postDelayed(() -> {
            context.startActivity(intent); // Start the new activity
        }, 500);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater=getMenuInflater();
        inflater.inflate(R.menu.menu_item,menu);
        return true;
    }//OnoptionMenu end here..................................................................

    @Override
    public boolean onOptionsItemSelected(@NonNull MenuItem item) {
        if (item.getItemId()==R.id.policyid){
            PrivacyActivity.url1=policy;
            Intent intent =new Intent(MainActivity.this, PrivacyActivity.class);
            startActivity(intent);
        }if (item.getItemId()==R.id.datadelete){
            PrivacyActivity.url1=delationrights;
            Intent intent =new Intent(MainActivity.this, PrivacyActivity.class);
            startActivity(intent);
        }
        return super.onOptionsItemSelected(item);
    }//OnOption Item end here.....................................................................................

    @Override
    public void onBackPressed() {
        long currentTime= System.currentTimeMillis();
        if (currentTime - lastBackPressed < Double_Click_InterVal)
        {
            super.onBackPressed();
        }else {
            Toast.makeText(this, "Press back again to exit", Toast.LENGTH_SHORT).show();
            lastBackPressed=currentTime;
        }

    }

}



