package com.rma.epstopik_bengaliword;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;
import android.content.Context;
import android.content.DialogInterface;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.Toast;
import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.JsonArrayRequest;
import com.android.volley.toolbox.Volley;
import com.google.android.gms.ads.AdError;
import com.google.android.gms.ads.FullScreenContentCallback;
import com.rma.epstopik_bengaliword.Admov.AdClass;
import com.rma.epstopik_bengaliword.Admov.ControlAd;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import java.util.ArrayList;
import java.util.HashMap;

public class QuestionViewActivity extends AppCompatActivity {

   private RecyclerView question_RclView;
    private ProgressBar progressBar;
   private HashMap<String, String> hashMap;
   private final ArrayList<HashMap<String, String>> list = new ArrayList<>();
    public static String url;

    // Variable to keep track of the currently selected position
    final int selectedPosition = -1;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_question_view);
        question_RclView = findViewById(R.id.question_RclView);
        progressBar = findViewById(R.id.progressBar);

        LinearLayout adContainer=findViewById(R.id.adContainer);
        if (adContainer!=null){
            AdClass.requestBannerAds(this,adContainer);
        } else if(adContainer==null) {
            adContainer.setVisibility(View.GONE);
        }


        if (isNetworkAvailable()) {
            fetchData();
        } else {
            Dialog(); // Show dialog indicating no internet connection
        }
    }

    private class QuestionAdapter extends RecyclerView.Adapter<QuestionAdapter.QuestionViewHolder>{
        @NonNull
        @Override
        public QuestionViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
            LayoutInflater layoutInflater= getLayoutInflater();
            View view = layoutInflater.inflate(R.layout.question_item,parent,false);
            return new QuestionViewHolder(view);
        }
        @Override
        public void onBindViewHolder(@NonNull QuestionViewHolder holder, int position) {
            hashMap = list.get(position);
            String question11 = hashMap.get("question");
            String option11 = hashMap.get("option1");
            String option22 = hashMap.get("option2");
            String option33 = hashMap.get("option3");
            String option44 = hashMap.get("option4");
            String answer = hashMap.get("answer");
            holder.question.setText(question11);

            holder.optionA.setText(option11);
            holder.optionB.setText(option22);
            holder.optionC.setText(option33);
            holder.optionD.setText(option44);

            holder.radioGroup.setOnCheckedChangeListener(null); // Clear previous listener

            // Set a tag to the RadioGroup to identify which position it belongs to
            holder.radioGroup.setTag(position);

            // Check if this position is the currently selected position
            boolean isSelected = selectedPosition == position;
            holder.optionA.setChecked(isSelected && option11.equals(answer));
            holder.optionB.setChecked(isSelected && option22.equals(answer));
            holder.optionC.setChecked(isSelected && option33.equals(answer));
            holder.optionD.setChecked(isSelected && option44.equals(answer));

            holder.radioGroup.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
                @Override
                public void onCheckedChanged(RadioGroup group, int checkedId) {
                    // Handle the radio button selection here
                    handleRadioButtonSelection(holder, answer, checkedId);
                }
            });
        }

        private void handleRadioButtonSelection(QuestionViewHolder holder, String answer, int checkedId) {
            String selectedOption = "";

            if (checkedId==R.id.optionA){
                selectedOption = holder.optionA.getText().toString();

            } if (checkedId==R.id.optionB){
                selectedOption = holder.optionB.getText().toString();

            } if (checkedId==R.id.optionC){
                selectedOption = holder.optionC.getText().toString();

            } if (checkedId==R.id.optionD){
                selectedOption = holder.optionD.getText().toString();

            }
            if (selectedOption.equals(answer)) {
                Toast.makeText(QuestionViewActivity.this, "Correct", Toast.LENGTH_SHORT).show();
            }else {
                Toast.makeText(QuestionViewActivity.this, "Incorrect", Toast.LENGTH_SHORT).show();

            }
        }

        @Override
        public int getItemCount() {
            return list.size();
        }

        private class QuestionViewHolder extends RecyclerView.ViewHolder{
            TextView question;
            RadioGroup radioGroup;
            RadioButton optionA,optionB, optionC, optionD;

            public QuestionViewHolder(@NonNull View itemView) {
                super(itemView);

                question=itemView.findViewById(R.id.question);
                radioGroup=itemView.findViewById(R.id.radioGroup);
                optionA=itemView.findViewById(R.id.optionA);
                optionB=itemView.findViewById(R.id.optionB);
                optionC=itemView.findViewById(R.id.optionC);
                optionD=itemView.findViewById(R.id.optionD);
            }
        }
    }

    void AlertDial(){
        AlertDialog.Builder builder=new AlertDialog.Builder(QuestionViewActivity.this);
        builder.setTitle("Server Error");
        builder.setMessage("Please try again later. we are solving this issue");
       builder.show();
    }
    void Dialog(){
        AlertDialog.Builder builder = new AlertDialog.Builder(QuestionViewActivity.this);
        builder.setTitle("No Internet !");
        builder.setMessage("Please check your internet connection");
        builder.setPositiveButton("Retry", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                if (isNetworkAvailable()) {
                    fetchData();
                } else {
                    Dialog(); // Show dialog indicating no internet connection
                }
            }
        });
        builder.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
                finish();
            }
        });
        builder.setCancelable(false);
        builder.show();

    }
    private boolean isNetworkAvailable() {
        ConnectivityManager connectivityManager = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo networkInfo = connectivityManager.getActiveNetworkInfo();
        return networkInfo != null && networkInfo.isConnected();
    }
    private void fetchData() {
        if (url!=null && !url.isEmpty()){
            JsonArrayRequest jsonArrayRequest = new JsonArrayRequest(Request.Method.GET, url, null, new Response.Listener<JSONArray>() {
                @Override
                public void onResponse(JSONArray response) {
                    progressBar.setVisibility(View.GONE);
                    Toast.makeText(QuestionViewActivity.this, "success", Toast.LENGTH_SHORT).show();
                    try {
                        for (int x = 0; x < response.length(); x++) {
                            JSONObject jsonObject = response.getJSONObject(x);
                            String question = jsonObject.getString("question");
                            String option1 = jsonObject.getString("option1");
                            String option2 = jsonObject.getString("option2");
                            String option3 = jsonObject.getString("option3");
                            String option4 = jsonObject.getString("option4");
                            String answer = jsonObject.getString("answer");

                            // Add question details to the list
                            hashMap = new HashMap<>();
                            hashMap.put("question", question);
                            hashMap.put("option1", option1);
                            hashMap.put("option2", option2);
                            hashMap.put("option3", option3);
                            hashMap.put("option4", option4);
                            hashMap.put("answer", answer);
                            list.add(hashMap);
                        }

                        QuestionAdapter adapter = new QuestionAdapter();
                        question_RclView.setLayoutManager(new LinearLayoutManager(QuestionViewActivity.this));
                        question_RclView.setAdapter(adapter);
                    } catch (JSONException e) {
                        throw new RuntimeException(e);
                    }
                }
            }, new Response.ErrorListener() {
                @Override
                public void onErrorResponse(VolleyError error) {
                    progressBar.setVisibility(View.GONE);
                    AlertDial();
                }
            });

            RequestQueue queue = Volley.newRequestQueue(this);
            queue.add(jsonArrayRequest);

        }else {
            Toast.makeText(this, "Please Stay connected . We are solving very soon", Toast.LENGTH_SHORT).show();
        }

    }

    @Override
    public void onBackPressed() {
        if (ControlAd.Clicked==3) {
            ControlAd.Clicked=0;
            if (AdClass.mInterstitialAd!=null){
                AdClass.mInterstitialAd.show(this);
                AdClass.mInterstitialAd.setFullScreenContentCallback(new FullScreenContentCallback() {
                    @Override
                    public void onAdDismissedFullScreenContent() {
                        super.onAdDismissedFullScreenContent();
                        AdClass.loadFullScreenAd(QuestionViewActivity.this);
                        QuestionViewActivity.super.onBackPressed();
                        ControlAd.Clicked++;
                    }

                    @Override
                    public void onAdFailedToShowFullScreenContent(@NonNull AdError adError) {
                        super.onAdFailedToShowFullScreenContent(adError);
                        AdClass.loadFullScreenAd(QuestionViewActivity.this);
                    }
                });
            }else {
                super.onBackPressed();
                ControlAd.Clicked++;
            }

        }else {
            super.onBackPressed();
            ControlAd.Clicked++;
        }
    }

}
