package com.rma.epstopik_bengaliword;


import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.content.ContextCompat;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;
import com.google.android.gms.ads.AdError;
import com.google.android.gms.ads.FullScreenContentCallback;
import com.rma.epstopik_bengaliword.Admov.AdClass;
import com.rma.epstopik_bengaliword.Admov.ControlAd;
import com.rma.epstopik_bengaliword.TTS.TTSSingleton;


public class WordActivity extends AppCompatActivity {
    ListView word_listView;
    public static String[] strings;
    private TTSSingleton ttsSingleton;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        long startTime = System.currentTimeMillis();  // Start time before any initialization
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_word);
        getWindow().setStatusBarColor(ContextCompat.getColor(this, R.color.status));

        AdClass.requestFullScreenAds(WordActivity.this);

        LinearLayout adContainer=findViewById(R.id.adContainer);
        if (adContainer!=null){
            AdClass.requestBannerAds(this,adContainer);
        } else if(adContainer==null) {
            adContainer.setVisibility(View.GONE);
        }

        word_listView = findViewById(R.id.word_listView);
        MyAdapter adapter = new MyAdapter();
        word_listView.setAdapter(adapter);

        ttsSingleton = TTSSingleton.getInstance(this);
        long endTime = System.currentTimeMillis();
        Log.d("WordActivity", "onCreate execution time: " + (endTime - startTime) + " ms");
    }

    private class MyAdapter extends BaseAdapter {
        @Override
        public int getCount() {
            return strings.length;
        }

        @Override
        public Object getItem(int position) {
            return strings[position];
        }

        @Override
        public long getItemId(int position) {
            return position;
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {
            LayoutInflater layoutInflater = LayoutInflater.from(WordActivity.this);
            View itemView = layoutInflater.inflate(R.layout.word_viewer, parent, false);

            TextView textView = itemView.findViewById(R.id.word_text);
            ImageView playBtn = itemView.findViewById(R.id.playbtn);

            textView.setText(strings[position]);

            playBtn.setOnClickListener(v -> {
                String string = strings[position];
                String[] parts = string.split("➝");
                if (parts.length > 0) {
                    String wordToSpeak = parts[0];
                    ttsSingleton.speak(wordToSpeak,WordActivity.this);                }
            });

            return itemView;
        }
    }


    @Override
    protected void onDestroy() {
        if (ttsSingleton != null) {
            ttsSingleton.shutdown();
        }
        super.onDestroy();
    }

    @Override
    public void onBackPressed() {
        MainActivity.currentDialog.dismiss();
        if (ControlAd.Clicked>=3) {
            if (AdClass.mInterstitialAd!=null){
                AdClass.mInterstitialAd.show(this);
                AdClass.mInterstitialAd.setFullScreenContentCallback(new FullScreenContentCallback() {
                    @Override
                    public void onAdDismissedFullScreenContent() {
                        super.onAdDismissedFullScreenContent();
                        AdClass.loadFullScreenAd(WordActivity.this);
                        WordActivity.super.onBackPressed();
                        ControlAd.Clicked=0;
                    }

                    @Override
                    public void onAdFailedToShowFullScreenContent(@NonNull AdError adError) {
                        super.onAdFailedToShowFullScreenContent(adError);
                    }
                });
            }else {
                super.onBackPressed();
            }

        }else {
            super.onBackPressed();
            ControlAd.Clicked++;
        }

    }
}