package com.rma.epstopik_bengaliword.fragments;

import android.os.Bundle;
import androidx.fragment.app.Fragment;
import android.speech.tts.TextToSpeech;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.GridView;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;
import com.rma.epstopik_bengaliword.R;

import java.util.Locale;


public class HangulFragment1 extends Fragment {
    private GridView hangul;

    private String[] strings;
    private H1Adapter myAdapter;
    private static TextToSpeech tts;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View view= inflater.inflate(R.layout.fragment_hangul1, container, false);
        hangul=view.findViewById(R.id.hangul1);



        tts = new TextToSpeech(getContext(), status -> {
            if (status == TextToSpeech.SUCCESS) {
                int result = tts.setLanguage(Locale.KOREA);
                if (result == TextToSpeech.LANG_MISSING_DATA || result == TextToSpeech.LANG_NOT_SUPPORTED) {
                    Toast.makeText(getContext(), "Language not supported", Toast.LENGTH_SHORT).show();
                }
                tts.setSpeechRate(.9f);
            } else {
                Toast.makeText(getContext(), "TextToSpeech initialization failed", Toast.LENGTH_SHORT).show();
            }
        }); //tts end here..............................


                strings = getResources().getStringArray(R.array.sorbonno);
            if (strings != null) {
                myAdapter=new H1Adapter();
                hangul.setAdapter(myAdapter);
            }


        return view;
    }

    private class H1Adapter extends BaseAdapter {
        @Override
        public int getCount() {
            return strings.length;
        }

        @Override
        public Object getItem(int position) {
            return strings[position];
        }

        @Override
        public long getItemId(int position) {
            return position;
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {
            LayoutInflater layoutInflater = LayoutInflater.from(getContext());
            View itemView = layoutInflater.inflate(R.layout.hangul_view_sample, parent, false);

            TextView textView = itemView.findViewById(R.id.hangul_textView);
            ImageView playBtn = itemView.findViewById(R.id.playbtn);

            textView.setText(strings[position]);

            playBtn.setOnClickListener(v -> {
                String string=strings[position];
                tts.speak(string, TextToSpeech.QUEUE_FLUSH,null,null);

            });

            return itemView;
        }
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        // Release TextToSpeech resources
        if (tts != null) {
            tts.stop();
            tts.shutdown();
        }
    }
}